/*
 *      p6-1.c
 *      Beispielprogramm 1, Abschnitt 6
 *      Alle Zeilen mit Suchmuster finden
 */

#include <stdio.h>

#define MAXLINE 1000

int getline(char [], int);
int index(char [], char []);

void main(void)
{
  char line[MAXLINE];
  
  while (getline(line, MAXLINE - 1) > 0)
    if (index(line, "the") > 0)
      printf("%s", line);

} /* main() */

/* Zeile in s ablegen, Lnge liefern */
int getline(char s[], int lim)
{ 
  int c, i;
  
  i = 0;
  while (--lim > 0 && (c = getchar()) != EOF && c != '\n')
    s[i++] = c;
  if (c == '\n')
    s[i++] = c;
  s[i] = '\0';
  return(i);

} /* getline() */

/* Position von t in s liefern, -1 falls nicht da */
int index (char s[], char t[])    
{ 
  int i, j, k;
  
  for (i = 0; s[i] != '\0'; i++) {
    for (j = i, k = 0; t[k] != '\0' && s[j] == t[k]; j++, k++)
      ;
    if (t[k] == '\0')
      return(i);
  }
  return(-1);
  
} /* index() */
