/*
 *      p7-5.c
 *      Beispielprogramm 5, Abschnitt 7
 *      Einfache Speicherverwaltung
 */

#define NULL 0          /* Zeigerwert fuer Fehleranzeige */
#define ALLOCSIZE 1000  /* verfuegbarer Platz */

static char allocbuf[ALLOSIZE];
static char *allocp = allocbuf; /* naechste freie Position */

/* liefert Zeiger auf Platz fuer n Zeichen */
char *alloc(int n)
{
  if (allocp + n <= allocbuf + ALLOCSIZE) {     /* reicht */
    allocp += n;
    return (allocp - n);        /* alter Zeiger */
  } 
  else                          /* nicht genug Platz */
    return (NULL);

} /* alloc() */

/* Speicher ab p freigeben */
void free(char *p) 
{
  if (p >= allocbuf && p <= allocbuf + ALLOCSIZE)
    allocp = p;

} /* free() */
